<?php
/**
 *
 */
class syslogistics_data_area {

    public function __construct()
    {
        if(config::get('cache.enabled', true))
        {
            cacheobject::get('areaKvdata',$areaKvdataCache);
            $this->areaKvdata = $areaKvdataCache['area'];
            $this->areaIdPath = $areaKvdataCache['areaIdPath'];
        }

        if( !$areaKvdataCache )
        {
            $this->areaKvdata = $this->__preKeyValue();
            $areaKvdataCache['area'] = $this->areaKvdata;
            $areaKvdataCache['areaIdPath'] = $this->areaIdPath;
            cacheobject::set('areaKvdata',$areaKvdataCache);
        }
    }

    public function __getAreaFileContents()
    {
        $staticsHostUrl = kernel::get_app_statics_host_url();
        $fileDir = $staticsHostUrl.'/ectools/statics/scripts/area.json';
        $this->areaFileContents = json_decode(file_get_contents($fileDir),true);
        return $this->areaFileContents;
    }

    /**
     * 返回地区ID和地区名
     */
    private function __preKeyValue($contents, $areaKvdata = array())
    {
        if( !$contents ) $contents = $this->__getAreaFileContents();
        foreach( $contents as $key=>$value )
        {
            $this->areaIdPath[$value['parentId']][] = $value['id'];

            $areaKvdata[$value['id']]['value'] = $value['value'];
            $areaKvdata[$value['id']]['parentId'] = $value['parentId'];
            if( !empty($value['children']) )
            {
                $areaKvdata = $this->__preKeyValue($value['children'], $areaKvdata);
            }
        }
        return $areaKvdata;
    }

    /**
     * 根据地区ID返回地区名称
     *
     * @param $areaId 地区ID
     */
    public function getAreaNameById($areaId)
    {
        return $this->areaKvdata[$areaId]['value'];
    }

    public function areaKvdata()
    {
        return $this->areaKvdata;
    }

    /**
     * 三级联动选择，根据选择的地区ID返回地区名称
     *
     * @param $areaId 地区ID  以逗号隔开的地区ID
     *
     * return array | bool
     */
    public function getSelectArea($areaIds)
    {
        if( !$this->checkArea($areaIds) ) return false;

        foreach( explode(',',$areaIds) as $id )
        {
            if( $area = $this->getAreaNameById($id) )
            {
                $name[] = $area;
            }
        }

        $areaName = implode('/',$name);
        return $areaName;
    }

    /**
     * 检查联动的ID是否是合法的
     *
     * @param $areaId 地区ID  以逗号隔开的地区ID
     *
     * return bool
     */
    public function checkArea($areaIds)
    {
        $ids = explode(',',$areaIds);
        foreach( $ids as $id )
        {
            if( $parentId )
            {
                if( !in_array($id,$this->areaIdPath[$parentId]) ) return false;
            }
            $parentId = $id;
        }
        return true;
    }
}

