<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2010 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */

return array(
    'columns' => array(
        'consultation_id' => array(
            'type' => 'bigint',
            'autoincrement' => true,
            'required' => true,
            'comment' => app::get('sysrate')->_('咨询自增编号'),
        ),
        'be_reply_id' => array(
            'type' => 'bigint',
            'default' => 0,
            'comment' => app::get('sysrate')->_('被回复的咨询id'),
        ),
        'item_title' => array(
            'type' => 'string',
            'length' => 1023,
            'required' => true,
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
            'label' => app::get('sysrate')->_('商品'),
            'comment' => app::get('sysrate')->_('被咨询的商品标题'),
            'order' =>'1',
        ),
        'shop_name' => array(
            'type' => 'string',
            'length' => 70,
            'width' => '70',
            'required' => true,
            'label' => app::get('sysrate')->_('所属店铺'),
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('所属店铺'),
            'filtertype' => 'has',
            'filterdefault' => true,
            'order' =>'2',
        ),
        'author' => array(
            'type' => 'string',
            'length' => 60,
            'label' => app::get('sysrate')->_('操作人'),
            'width' => '40',
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('操作人'),
            'filtertype' => 'yes',
            'filterdefault' => true,
            'order' =>'3',
        ),
        'consultation_type' => array(
            'type' => array(
                'item' => '商品咨询',
                'store_delivery' => '库存/配送咨询',
                'payment' =>' 支付方式咨询',
                'invoice' => '发票保修咨询',
            ),
            'default' => 'item',
            'comment' => app::get('sysrate')->_('咨询类型'),
            'label' => app::get('sysrate')->_('咨询类型'),
            'filtertype' => 'yes',
            'filterdefault' => true,
            'order' =>'4',
            'width' => '40',
        ),
        'contack' => array(
            'type' => 'string',
            'length' => 200,
            'label' => app::get('sysrate')->_('联系方式'),
            'width' => '20',
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('联系方式'),
            'order' =>'5',
        ),
        'content' => array(
            'type' => 'string',
            'default' => '',
            'length' => 1023,
            'width' => '100',
            'label' => app::get('sysrate')->_('咨询内容'),
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('商品咨询的内容'),
            'filtertype' => 'has',
            'filterdefault' => true,
            'order' =>'6',
        ),
        'is_reply' => array(
            'type' => 'bool',
            'default' => '0',
            'label' => app::get('sysrate')->_('是否回复'),
            'in_list' => true,
            'default_in_list' => false,
            'comment' => app::get('sysrate')->_('商品咨询是否被回复'),
            'order' =>'7',
            'width' => '10',
            'filtertype' => 'bool',
            'filterdefault' => true,
        ),
        'created_time' => array(
            'type' => 'time',
            'label' => app::get('sysrate')->_('咨询时间'),
            'width' => '40',
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('创建时间'),
            'order' =>'8',
        ),
         'ip' => array(
            'type' => 'string',
            'label' => app::get('sysrate')->_('ip'),
            'in_list' => true,
            'default_in_list' => true,
            'comment' => app::get('sysrate')->_('消费者发起咨询时的ip'),
            'order' =>'11',
            'width' => '20',
        ),
        'is_display' => array(
            'type' => array('true' =>'显示','false'=>'不显示'),
            'default' => 'false',
            'label' => app::get('sysrate')->_('是否显示至商祥页'),
            'comment' => app::get('sysrate')->_('是否显示至商祥页'),
        ),
        'shop_id' => array(
            'type' => 'table:shop@sysshop',
            'required' => true,
            'comment' => app::get('sysrate')->_('店铺ID'),
        ),
        'item_id' => array(
            'type' => 'bigint',
            'required' => true,
            'comment' => app::get('sysrate')->_('被咨询的商品id'),
        ),
        'author_id' => array(
            'type' => 'bigint',
            'comment' => app::get('sysrate')->_('操作人id'),
        ),
        'is_anonymity' => array(
            'type' => 'bool',
            'default' => 0,
            'comment' => app::get('sysrate')->_('是否匿名'),
        ),
        'modified_time' => array(
            'type' => 'last_modify',
            'label' => app::get('sysrate')->_('最后修改时间'),
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
        ),
        'image_default_id' => array(
            'type' => 'string',
            'comment' => app::get('sysrate')->_('商品默认图'),
        ),
    ),
    'index' => array(
        'ind_item_id' => ['columns' => ['item_id']],
        'ind_shop_id' => ['columns' => ['shop_id']],
    ),
    'primary' => 'consultation_id',
    'comment' => app::get('sysrate')->_('商品咨询表'),
);
