<?php

return  array(
    'columns' => array(
        'id' => array(
            'type' => 'bigint',
            'unsigned' => true,
            'required' => true,
            'autoincrement' => true,
            'comment' => app::get('sysrate')->_('ID'),
        ),
        'seller_id' => array(
            'type' => 'bigint',
            'unsigned' => true,
            'default' => '0',
            'required' => true,
            'comment' => app::get('sysrate')->_('用户ID'),
        ),
        'shop_id' => array(
            'type' => 'bigint',
            'default' => '0',
            'required' => true,
            'comment' => app::get('sysrate')->_('店铺ID'),
        ),
        'status' => array(
            'type' => array(
                'active' => '未处理',
                'closed' => '已关闭',
            ),
            'default' => 'active',
            'required' => true,
            'in_list' => true,
            'default_in_list' => false,
            'label' => app::get('sysrate')->_('状态'),
        ),
        'name' => array(
            'type' => 'string',
            'length' => 32,
            'default' => '',
            'required' => true,
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'in_list' => true,
            'default_in_list' => false,
            'label' => app::get('sysrate')->_('姓名'),
            'order' => 10,
        ),
        'email' => array(
            'type' => 'string',
            'length' => 100,
            'default' => 0,
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'in_list' => true,
            'default_in_list' => false,
            'label' => app::get('sysrate')->_('邮箱'),
            'order' => 20,
        ),
        'tel' => array(
            'type' => 'string',
            'default' => '',
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'length' => 100,
            'label' => app::get('sysrate')->_('电话'),
            'in_list' => true,
            'default_in_list' => false,
            'order' => 30,
        ),
        'question' => array(
            'type' => 'string',
            'default' => '',
            'in_list' => true,
            'width' => '300',
            'default_in_list' => true,
            'label' => app::get('sysrate')->_('问题'),
            'order' => 40,
        ),
        'memo' => array(
            'type' => 'string',
            'default' => '',
            'in_list' => true,
            'width' => '300',
            'default_in_list' => true,
            'label' => app::get('sysrate')->_('处理备注'),
            'order' => 50,
        ),
        'modified_time' => array(
            'type' => 'last_modify',
            'label' => app::get('sysrate')->_('最后修改时间'),
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
            'order' => 60,
        ),
    ),
    'primary' => 'id',
    'comment' => app::get('sysrate')->_('意见反馈表'),
);
