<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2010 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */

class topm_ctl_memberItem extends topm_controller {

    public function userNotifyItem()
    {
        try
        {
            $postdata = $this->__checkdata(input::get());
            $params['shop_id'] = $postdata['shop_id'];
            $params['item_id'] = $postdata['item_id'];
            $params['sku_id'] = $postdata['sku_id'];
            $params['email'] = $postdata['email'];
            app::get('topm')->rpcCall('user.notifyitem',$params);
        }
        catch (Exception $e)
        {
            $msg = $e->getMessage();
            return $this->splash('error',null,$msg);
        }
        $msg = app::get('topm')->_('预订成功');
        return $this->splash('success',null,$msg);
    }
    private function __checkdata($data)
    {
        if($data['shop_id']=='')
        {
             throw new \LogicException('店铺id不能为空！');
        }
        if($data['item_id']=='')
        {
             throw new \LogicException('商品id不能为空！');
        }
        if($data['sku_id']=='')
        {
             throw new \LogicException('货品id不能为空！');
        }
        if($data['email']=='')
        {
             throw new \LogicException('email不能为空！');
        }
        if(!preg_match('/^(?:[a-z\d]+[_\-\+\.]?)*[a-z\d]+@(?:([a-z\d]+\-?)*[a-z\d]+\.)+([a-z]{2,})+$/i',trim($data['email'])) )
        {
            throw new \LogicException('邮件格式不正确');
        }
        return $data;
    }
}